/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) for vocabulary details.
    /// </summary>
    [DataContract(Name = "VocabularyDto")]
    public partial class VocabularyDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="VocabularyDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected VocabularyDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="VocabularyDto" /> class.
        /// </summary>
        /// <param name="graphUri">The URI of the graph containing the vocabulary. (required).</param>
        /// <param name="classUri">The URI of the top-level parent class in the vocabulary. (required).</param>
        /// <param name="displayName">The display name of the vocabulary..</param>
        /// <param name="description">The description of the vocabulary..</param>
        public VocabularyDto(string graphUri = default(string), string classUri = default(string), string displayName = default(string), string description = default(string))
        {
            // to ensure "graphUri" is required (not null)
            if (graphUri == null)
            {
                throw new ArgumentNullException("graphUri is a required property for VocabularyDto and cannot be null");
            }
            this.GraphUri = graphUri;
            // to ensure "classUri" is required (not null)
            if (classUri == null)
            {
                throw new ArgumentNullException("classUri is a required property for VocabularyDto and cannot be null");
            }
            this.ClassUri = classUri;
            this.DisplayName = displayName;
            this.Description = description;
        }

        /// <summary>
        /// The URI of the graph containing the vocabulary.
        /// </summary>
        /// <value>The URI of the graph containing the vocabulary.</value>
        [DataMember(Name = "graphUri", IsRequired = true, EmitDefaultValue = true)]
        public string GraphUri { get; set; }

        /// <summary>
        /// The URI of the top-level parent class in the vocabulary.
        /// </summary>
        /// <value>The URI of the top-level parent class in the vocabulary.</value>
        [DataMember(Name = "classUri", IsRequired = true, EmitDefaultValue = true)]
        public string ClassUri { get; set; }

        /// <summary>
        /// The display name of the vocabulary.
        /// </summary>
        /// <value>The display name of the vocabulary.</value>
        [DataMember(Name = "displayName", EmitDefaultValue = true)]
        public string DisplayName { get; set; }

        /// <summary>
        /// The description of the vocabulary.
        /// </summary>
        /// <value>The description of the vocabulary.</value>
        [DataMember(Name = "description", EmitDefaultValue = true)]
        public string Description { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class VocabularyDto {\n");
            sb.Append("  GraphUri: ").Append(GraphUri).Append("\n");
            sb.Append("  ClassUri: ").Append(ClassUri).Append("\n");
            sb.Append("  DisplayName: ").Append(DisplayName).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
